var startTime = Date.now();
export function createLoadingMiddleware(_ref) {
    var start = _ref.start,
        end = _ref.end,
        minDuration = _ref.minDuration;

    var i = 0;
    return function (ctx) {
        return {
            beforeRender: function beforeRender() {
                if (i++ === 0) {
                    startTime = Date.now();
                    start(ctx);
                }
            },
            afterRender: function afterRender() {
                if (--i === 0) {
                    if (minDuration) {
                        var elapsed = Date.now() - startTime;
                        var delay = minDuration - elapsed;
                        // negative delay will be called immediately
                        setTimeout(function () {
                            return end(ctx);
                        }, delay);
                    } else {
                        end(ctx);
                    }
                }
            }
        };
    };
}
//# sourceMappingURL=index.js.map