let startTime = Date.now();
export function createLoadingMiddleware({ start, end, minDuration, }) {
    let i = 0;
    return (ctx) => ({
        beforeRender() {
            if (i++ === 0) {
                startTime = Date.now();
                start(ctx);
            }
        },
        afterRender() {
            if (--i === 0) {
                if (minDuration) {
                    const elapsed = Date.now() - startTime;
                    const delay = minDuration - elapsed;
                    // negative delay will be called immediately
                    setTimeout(() => end(ctx), delay);
                }
                else {
                    end(ctx);
                }
            }
        },
    });
}
//# sourceMappingURL=index.js.map